#include <string.h>
#include <stdio.h>

#ifdef __WIN32__
#include <windows.h>
#define EXPORT __export
#else
#define EXPORT 
#endif
#include "main.h"

char *file_info="TXT (Plain text)";
char *file_mime="text/plain";
char *file_shrt="Plain Text"; /* Maximum length - 15 characters */
TPluginWord w;
unsigned long cur_pos;
bool first,is_symb;

char is_char[256]={
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

char is_upcase[256]={
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

#ifdef __WIN32__
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved) {
    return 1;
    }
#endif;


/*   -    ( ) */
extern "C" char* EXPORT get_info(void)  {
    return(file_info);
	}


/*   -  MIME TYPE,    , */
/*    "|" */
extern "C" char* EXPORT get_mime(void)  {
    return(file_mime);
	}


/*   -     (   ,  
/* HTML    */
extern "C" char* EXPORT get_shortdesc(void)  {
    return(file_shrt);
	}


/*   -  Range  HTTP  ( RFC2068),  Range 
/* ,      ,     NULL */
extern "C" char* EXPORT get_range(void)  {
    return(NULL);
	}


/*   - title  */
/*  NULL,   ,   URL  */
#pragma argsused
extern "C" char* EXPORT get_title(unsigned char *d, unsigned long filesize)  {
	cur_pos=0;
	first=true;
	is_symb=false;
	d[filesize]=0;
    return(NULL);
	}

/* d -    .    \0x0 */
/* filesize -   . ,   
/*               \0x00 */
/*   TPluginWord */
extern "C" TPluginWord* EXPORT get_word(unsigned char *d, unsigned long filesize)  {
	bool found=false;

	if (first) {
		if (strstr((char*)d,"\n\r\n\r")) cur_pos=(unsigned long)strstr((char*)d,"\n\r\n\r")-(unsigned long)d+4;
		else if (strstr((char*)d,"\n\n")) cur_pos=(unsigned long)strstr((char*)d,"\n\n")-(unsigned long)d+2;
		else if (strstr((char*)d,"\r\n\r\n")) cur_pos=(unsigned long)strstr((char*)d,"\r\n\r\n")-(unsigned long)d+4;
		}
	if (is_symb) {
		w.word[0]=d[cur_pos];
		if (w.word[0]==0) w.end=true; else w.end=false;
		w.word[1]=0;
		w.rel=2;
		cur_pos++;
		is_symb=false;
	    return(&w);
		}
	first=false;
	int word_pos=0;
	w.end=false;
	w.rel=2;
	while (!found) {
		if (is_char[d[cur_pos]]) {
			if (!is_upcase[d[cur_pos]]) w.rel=1;
			w.word[word_pos]=d[cur_pos];
			word_pos++;
			cur_pos++;
			if (word_pos>31) word_pos=31;
			}
		else {
			found=true;
			if (word_pos!=0) {
				is_symb=true;
				w.word[word_pos]=0;
				}
			else {
				w.word[0]=d[cur_pos];
				if (w.word[0]==0) w.end=true;
				w.word[1]=0;
				cur_pos++;
				}
			}
		}
    return(&w);
	}
